/*
 *
 *      winafsk.h v2.01b By Mikko Antero Gustafsson
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <time.h>
#include <windows.h>
#include <commctrl.h>

extern HWND g_hLogTextWindow;
extern HWND g_hDatabaseWindow;
extern char *PacketCountMessage;
extern BOOL  g_iPacketcount;
extern HWND g_hStatusBar;

//
//  Identity values for menu items
//
#define IDM_AUTOSCROLL  1
#define IDM_EXIT        2
#define IDM_ABOUT       20
#define IDM_CONTENTS    21
#define ID_BUT1         100
#define ID_COMBO        101
#define ID_REBAR        102
#define ID_DBHEADER     103
#define ID_DBLIST       104
#define IDM_SCOPEBUTTON 105
#define IDM_LOGBUTTON   106 
#define IDM_DBBUTTON    107
#define IDM_VOLUMEBUTTON 108
#define IDM_ARRANGEBUTTON 109
#define  IDC_ICONBIG    200
#define  IDC_ICONSMALL  201

#define CM_WINDOW_TILEVERT	9080
#define CM_WINDOW_TILEHORZ	9082
#define CM_WINDOW_ARRANGE	9081
#define CM_WINDOW_TILE	9080
#define CM_WINDOW_CASCADE	9076
#define CM_EDIT_PASTE	9079
#define CM_EDIT_COPY	9078
#define CM_EDIT_CUT	9077
#define CM_EDIT_REDO	9076
#define CM_EDIT_UNDO	9075
#define CM_FILE_SAVEAS	9074
#define CM_FILE_SAVE	9073
#define CM_FILE_OPEN	9072
#define CM_HELP_ABOUT	9072
#define CM_FILE_EXIT	9071
#define CM_FILE_NEW	9070

#define ID_STATUSBAR       4997
#define ID_TOOLBAR         4998
#define ID_MDI_CLIENT      4999
#define ID_MDI_FIRSTCHILD  50000
#define IDC_CHILD_EDIT      2000


//
//  These parameters may not be modified. The code is written specifically to
//  run with only these values.
//
#define BITS_PER_SAMP 16
#define BAUD          1200
#define FREQ_LOW      1200
#define FREQ_HIGH     2200
#define FREQ_SAMP     22050
#define SUBSAMP       2
#define CORRLEN       18
#define SPHASEINC     7133

#define M_PI        3.14159265358979323846
#define TRUE        1
#define FALSE       0

#define PACKET_LENGTH 512

//
//  Database related definitions
//
#define RecordMessageMaxLength PACKET_LENGTH
typedef struct
{
  long Flags;
  time_t TimeStamp;
  char From[32];
  char To[32];
  char Modulation[16];
  char Message[RecordMessageMaxLength];
} Record;
#define DB_RECORDSIZE sizeof(Record)

void    AddDatabaseListItem(Record *record);
void    InitializeList(HWND hList);
BOOL    GetNextRecord( void *record );
void    ParsePacket(struct demod_state *s, unsigned char *bp, unsigned int len, Record *pr);
void    InitialiseDemodulators(void);
void    CloseStream(void);
void    Demodulate(signed short *samplebuffer, int samplecount, int samplelength);
BOOL    OpenStream(PCMWAVEFORMAT *pwf);
void    WinAFSK_printf(HWND hWnd, const char *fmt, ...);
void    ReceivePacket(struct demod_state *s, unsigned char *bp, unsigned int len);
void    PrintString(HWND hWnd, char *szText);
void    CopyText(void);
BOOL    StreamData(HWAVEIN hwav, LPWAVEHDR pHdr);
void    OpenScopeWindow(void);
void    OpenVolumeWindow(void);
void    UpdateRebarStatusBox(Record *pr);
BOOL    OpenDatabase(void);
void    CloseDatabase(void);
void    ReadRegistry(DWORD dwMaxLen, unsigned char *pszDirectory);
BOOL    CenterWindow (HWND hwndChild, HWND hwndParent, int addx, int addy);
BOOL    AddNewRecord(Record *record);
BOOL    GetNextRecord(Record *record);
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK EditStreamCallback(DWORD *dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);
void    SetVolume(DWORD dwValue, int idComponent);
void    MixerChange(unsigned long dwControlID);
long    GetVolume(unsigned long dwControlID);
void    OpenMixer(void);
int     GetMixerControlID(long dwComponentType);
void    FillAudioDeviceComboBox(void);
void    WriteRegistry(void);

extern BOOL g_fAutoScroll;
extern char bufText[];
extern HWND g_hMainWindow;
extern char g_bufIncomingPacket[];
extern char szDebugBuf[];
